;------------------------------------------------------------------
; SelectoSurf
;  by mouser@donationcoder.com
;  see http://www.donationcoder.com/Forums/bb/index.php?topic=6714.0
;
; v 1.1.0, Jan 25, 2008 - improved browser option, added split-line reconstruction, added about box
; v 1.0.2, Nov 10, 2006 - initial release
;
; Select plaintext in any program and hit the hotkey (ctrl+space)
; If the text looks like a url or website name (like donationcoder.com), it will be opened
;  otherwise a google search will be confucted with the phrase.
;------------------------------------------------------------------



;------------------------------------------------------------------
; set version and info
versioninfo = v1.1.0 - Jan. 25, 2008
programtitle = SelectoSurf plaintext URL opener
programinfo = Let's you select a plaintext url and open it in browser.`r`nTo use, select a url in any program and hit Ctrl+Space.
programsite = http://www.donationcoder.com/Forums/bb/index.php?topic=6714.0
Gosub,TRAYMENU
;------------------------------------------------------------------



;------------------------------------------------------------------
#SingleInstance force
;------------------------------------------------------------------


;------------------------------------------------------------------
; ATTN, OPTIONAL: configure a specific browser overide, to bypass using default
;browserexe = iexplore.exe
;browserexe = C:\Program Files\Mozilla Firefox\firefox.exe
;------------------------------------------------------------------




;------------------------------------------------------------------
; trigger on control+space
; ATTN, OPTIONAL: add different trigger here if you prefer
^space:: 
;--------------------------


;--------------------------
; grab old clipboard
temp = %clipboard% 

; send ctrl+C to copy new text to clipboard
Send, ^c 

; sleep a tiny bit to give a chance for clipboard to propage
Sleep 100
;--------------------------


;--------------------------
; *potential* url
theurl = %clipboard%
;--------------------------


;--------------------------
; merge split lines
StringReplace, theurl, theurl, `r`n,, All
StringReplace, theurl, theurl, `r,, All
StringReplace, theurl, theurl, `n,, All

; clean spaces
StringReplace, theurl, theurl, %A_Space%,`%20, All

; Lets do some other common replacements
StringReplace, theurl, theurl, hxxp:,http:, All
StringReplace, theurl, theurl, hxxps:,http:, All
StringReplace, theurl, theurl, h??p:,http:, All
StringReplace, theurl, theurl, h??ps:,http:, All

; remove any leading or trailing () [] . " '
theurl := RegExReplace(theurl, "^[\.\(\)\'\[\]""]+")
theurl := RegExReplace(theurl, "[\.\(\)\'\[\]""]+$")
;--------------------------


;--------------------------
; is it a full url
isaurl = 0
IfInString, theurl, http:
{
	isaurl = 1
}
else IfInString, theurl, https:
{
	isaurl = 1
}
else IfInString, theurl, mailto
{
	isaurl = 1
}
else IfInString, theurl, ftp:
{
	isaurl = 1
}
else IfInString, theurl, www.
{
	isaurl = 1
}
else IfInString, theurl, .com
{
	isaurl = 1
	theurl = www.%theurl%
}
else IfInString, theurl, .net
{
	isaurl = 1
	theurl = www.%theurl%
}
else IfInString, theurl, .org
{
	isaurl = 1
	theurl = www.%theurl%
}
else
{
	; @sign with no spaces is an email
	; ATTN: toddo
	if (0==1)
		{
		; add a mailto
		theurl = mailto:%theurl%
		isaurl = 1
		}
	else
		{
		; search for the string - note this makes isaurl true always, which is what we want.
		theurl = http://www.google.com/search?hl=en&q=`%22%theurl%`%22
		isaurl = 1
		}
}
;--------------------------


;--------------------------
; launch it?
if (isaurl = 1)
{
	; beep?
	; SoundBeep
	
	; launch explorer with url
	if (browserexe != "")
		{
		Run, %browserexe% %theurl%
		}
	else
		{
		Run %theurl%
		}
}
;--------------------------


;--------------------------
; restore clipboard
clipboard = %temp% 
;--------------------------


;--------------------------
; all done
return
;--------------------------






;------------------------------------------------------------------
; tray menu for script - based on code by skrommel (http://www.donationcoder.com/Software/Skrommel/)

TRAYMENU:
Menu,Tray,Click,1
Menu,Tray,NoStandard 
Menu,Tray,DeleteAll 
Menu,Tray,Add,%applicationname%,DOUBLECLICK
Menu,Tray,Add,&About %programtitle%..,ABOUT
Menu,Tray,Add,&Quit,QUIT
Menu,Tray,Default,%applicationname%
Menu,Tray,Tip,%programtitle%
Return


DOUBLECLICK: 
Gosub,ABOUT
Return


QUIT:
ExitApp

;--------------------------
ABOUT:
Gui,2:Destroy
Gui,2:Add,Text,y-5,`t
Gui,2:Add,Picture,xm Icon13,%applicationname%.exe
Gui,2:Font,Bold
Gui,2:Add,Text,x yp+10,%programtitle%`r`n%versioninfo%
Gui,2:Font
Gui,2:Add,Text,xm,%programinfo%
Gui,2:Add,Text,y+0,`t

Gui,2:Add,Picture,xm Icon12,%applicationname%.exe
Gui,2:Font,Bold
Gui,2:Add,Text,x yp+10, Program Homepage
Gui,2:Font
Gui,2:Add,Text,xm,For more info visit
Gui,2:Font,CBlue Underline
Gui,2:Add,Text,xm GPROGRAMWEBSITE,%programsite%
Gui,2:Font
Gui,2:Add,Text,y+0,`t

Gui,2:Add,Picture,xm Icon15,%applicationname%.exe
Gui,2:Font,Bold
Gui,2:Add,Text,x yp+10,DonationCoder
Gui,2:Font
Gui,2:Add,Text,xm,Please support the DonationCoder community
Gui,2:Font,CBlue Underline
Gui,2:Add,Text,xm GDONATIONCODER,www.DonationCoder.com
Gui,2:Font
Gui,2:Add,Text,y+0,`t

Gui,2:Add,Picture,xm Icon11,%applicationname%.exe
Gui,2:Font,Bold
Gui,2:Add,Text,x yp+10,AutoHotkey
Gui,2:Font
Gui,2:Add,Text,xm,This program was made using AutoHotkey
Gui,2:Font,CBlue Underline
Gui,2:Add,Text,xm GAUTOHOTKEY,www.AutoHotkey.com
Gui,2:Font
Gui,2:Add,Text,y+0,`t

Gui,2:Add,Button,GABOUTOK Default w75,&OK
Gui,2:Show,,%applicationname% About
Return

PROGRAMWEBSITE:
Run,%programsite%,,UseErrorLevel
Return

DONATIONCODER:
Run,http://www.donationcoder.com,,UseErrorLevel
Return

AUTOHOTKEY:
Run,http://www.autohotkey.com,,UseErrorLevel
Return

ABOUTOK:
Gui,2:Destroy
Return
;------------------------------------------------------------------